"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Autocomplete = void 0;

var _startsWith2 = _interopRequireDefault(require("lodash/startsWith"));

var _some2 = _interopRequireDefault(require("lodash/some"));

var _pullAt2 = _interopRequireDefault(require("lodash/pullAt"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _GlobalListeners = require("./HOC/GlobalListeners");

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _props = require("../utils/props");

var _2 = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var AutocompleteBase =
/*#__PURE__*/
function (_Component) {
  _inherits(AutocompleteBase, _Component);

  var _super = _createSuper(AutocompleteBase);

  // declare ref types
  // define static properties
  function AutocompleteBase(props) {
    var _this;

    _classCallCheck(this, AutocompleteBase);

    _this = _super.call(this, props); // define refs

    _defineProperty(_assertThisInitialized(_this), "rootElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "suggestionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "optionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "clear", function () {
      return _this._removeOptions();
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.handleAutocompleteClick();
    });

    _defineProperty(_assertThisInitialized(_this), "open", function () {
      return _this.setState({
        isOpen: true
      });
    });

    _defineProperty(_assertThisInitialized(_this), "close", function () {
      return _this.setState({
        isOpen: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggleOpen", function () {
      if (_this.state.isOpen && _this.optionsElement && _this.optionsElement.current) {
        // set Options scroll position to top on close
        _this.optionsElement.current.scrollTop = 0;
      }

      _this.setState(function (prevState) {
        return {
          isOpen: !prevState.isOpen
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggleMouseLocation", function () {
      return _this.setState(function (prevState) {
        return {
          mouseIsOverOptions: !prevState.mouseIsOverOptions
        };
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleAutocompleteClick", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (inputElement && inputElement.current) {
        inputElement.current.focus();
      } // toggle options open/closed


      _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
      if ( // Check for backspace in order to delete the last selected option
      event.keyCode === 8 && !event.target.value && _this.state.selectedOptions.length) {
        // Remove last selected option
        _this.removeOption(_this.state.selectedOptions.length - 1, event);
      } else if (event.keyCode === 27) {
        // ESCAPE key: Stops propagation & modal closing
        event.stopPropagation();
      } else if (event.keyCode === 13) {
        // ENTER key: Opens suggestions
        _this.open();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputChange", function (event) {
      _this._setInputValue(event.target.value);

      var multipleValues = event.target.value.split(' ');

      if (multipleValues && multipleValues.length > 1) {
        _this.updateSelectedOptions(event, multipleValues);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (option, event) {
      _this.updateSelectedOptions(event, option);
    });

    _defineProperty(_assertThisInitialized(_this), "updateSelectedOptions", function (event) {
      var selectedOption = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var _this$props = _this.props,
          maxSelections = _this$props.maxSelections,
          multipleSameSelections = _this$props.multipleSameSelections;
      var _this$state = _this.state,
          selectedOptions = _this$state.selectedOptions,
          filteredOptions = _this$state.filteredOptions,
          isOpen = _this$state.isOpen;
      var canMoreOptionsBeSelected = maxSelections != null ? selectedOptions.length < maxSelections : true;
      var areFilteredOptionsAvailable = filteredOptions && filteredOptions.length > 0;
      var skipValueSelection = false;

      if (!maxSelections || canMoreOptionsBeSelected && areFilteredOptionsAvailable) {
        if (!selectedOption || !selectedOption.length) return;
        var option = (0, _isString2["default"])(selectedOption) ? selectedOption.trim() : selectedOption;

        var newSelectedOptions = _toConsumableArray(selectedOptions);

        if (option && Array.isArray(option)) {
          option.forEach(function (item) {
            var optionCanBeSelected = multipleSameSelections && filteredOptions.includes(item) || filteredOptions.includes(item) && !selectedOptions.includes(item) && !newSelectedOptions.includes(item);

            if (!optionCanBeSelected && !skipValueSelection) {
              _this._setInputValue(item, true);

              skipValueSelection = true;
              return;
            }

            if (item && optionCanBeSelected && isOpen && !skipValueSelection) {
              newSelectedOptions.push(item);
            }
          });
        } else {
          var optionCanBeSelected = multipleSameSelections || !selectedOptions.includes(option);

          if (option && optionCanBeSelected && isOpen) {
            newSelectedOptions.push(option);
          }
        }

        _this.selectionChanged(newSelectedOptions, event);

        _this.setState({
          selectedOptions: newSelectedOptions,
          isOpen: false
        });
      }

      if (!skipValueSelection) {
        _this._setInputValue('');
      }
    });

    _defineProperty(_assertThisInitialized(_this), "removeOption", function (index, event) {
      var selectedOptions = _this.state.selectedOptions;
      (0, _pullAt2["default"])(selectedOptions, index);

      _this.selectionChanged(selectedOptions, event);

      _this.setState({
        selectedOptions: selectedOptions
      });
    });

    _defineProperty(_assertThisInitialized(_this), "selectionChanged", function (selectedOptions, event) {
      if (_this.props.onChange) _this.props.onChange(selectedOptions, event);
    });

    _defineProperty(_assertThisInitialized(_this), "getSelectionProps", function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _removeSelection = _ref.removeSelection;

      var themeId = _this.props.themeId;
      var _this$state2 = _this.state,
          inputValue = _this$state2.inputValue,
          isOpen = _this$state2.isOpen,
          selectedOptions = _this$state2.selectedOptions,
          composedTheme = _this$state2.composedTheme;
      return {
        inputValue: inputValue,
        isOpen: isOpen,
        selectedOptions: selectedOptions,
        theme: composedTheme[themeId],
        removeSelection: function removeSelection(index, event) {
          return (// the user's custom removeSelection event handler is composed with
            // the internal functionality of Autocomplete (this.removeOption)
            (0, _props.composeFunctions)(_removeSelection, _this.removeOption)(index, event)
          );
        }
      };
    });

    _defineProperty(_assertThisInitialized(_this), "_removeOptions", function () {
      var onChange = _this.props.onChange;
      onChange ? onChange([]) : null;

      _this.setState({
        selectedOptions: [],
        inputValue: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_filterOptions", function (value) {
      var filteredOptions = [];

      if (value !== '') {
        (0, _some2["default"])(_this.props.options, function (option) {
          if ((0, _startsWith2["default"])(option, value)) {
            filteredOptions.push(option);
          }
        });
      } else {
        filteredOptions = _this.props.options;
      }

      return filteredOptions;
    });

    _defineProperty(_assertThisInitialized(_this), "_filterInvalidChars", function (value) {
      var filteredValue = '';

      if (_this.props.invalidCharsRegex.test(value)) {
        filteredValue = value.replace(_this.props.invalidCharsRegex, '');
      } else {
        filteredValue = value;
      }

      return filteredValue;
    });

    _defineProperty(_assertThisInitialized(_this), "_setInputValue", function (value, shouldFocus) {
      var multipleValues = value.split(' ');

      if (multipleValues && multipleValues.length > 1) {
        var filteredOptions = [];
        multipleValues.forEach(function (itemValue) {
          var filteredValue = _this._filterInvalidChars(itemValue);

          filteredOptions.push(_this._filterOptions(filteredValue));
        });

        _this.setState({
          isOpen: true,
          inputValue: '',
          filteredOptions: filteredOptions
        });
      } else {
        var filteredValue = _this._filterInvalidChars(value);

        var _filteredOptions = _this._filterOptions(filteredValue);

        _this.setState({
          isOpen: true,
          inputValue: filteredValue,
          filteredOptions: _filteredOptions
        });

        setTimeout(function () {
          if (shouldFocus) _this.focus();
        }, 0);
      }
    });

    _this.rootElement = (0, _createRef["default"])();
    _this.inputElement = (0, _createRef["default"])();
    _this.suggestionsElement = (0, _createRef["default"])();
    _this.optionsElement = (0, _createRef["default"])();
    var context = props.context,
        _themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides,
        sortAlphabetically = props.sortAlphabetically,
        options = props.options,
        preselectedOptions = props.preselectedOptions;
    _this.state = {
      inputValue: '',
      error: '',
      selectedOptions: preselectedOptions || [],
      filteredOptions: sortAlphabetically && options ? options.sort() : options || [],
      isOpen: false,
      mouseIsOverOptions: false,
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, _themeId), (0, _themes.addThemeId)(themeOverrides, _themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  _createClass(AutocompleteBase, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // destructuring props ensures only the "...rest" get passed down
      var _this$props2 = this.props,
          context = _this$props2.context,
          invalidCharsRegex = _this$props2.invalidCharsRegex,
          multipleSameSelections = _this$props2.multipleSameSelections,
          sortAlphabetically = _this$props2.sortAlphabetically,
          skin = _this$props2.skin,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          onChange = _this$props2.onChange,
          error = _this$props2.error,
          rest = _objectWithoutProperties(_this$props2, ["context", "invalidCharsRegex", "multipleSameSelections", "sortAlphabetically", "skin", "theme", "themeOverrides", "onChange", "error"]);

      var AutocompleteSkin = skin || context.skins[_2.IDENTIFIERS.AUTOCOMPLETE];
      return (
        /*#__PURE__*/
        _react["default"].createElement(_GlobalListeners.GlobalListeners, {
          mouseIsOverOptions: this.state.mouseIsOverOptions,
          optionsIsOpen: this.state.isOpen,
          optionsIsOpeningUpward: this.props.isOpeningUpward,
          optionsRef: this.optionsElement,
          rootRef: this.rootElement,
          toggleOpen: this.toggleOpen
        }, function (_ref2) {
          var optionsMaxHeight = _ref2.optionsMaxHeight,
              optionHeight = _ref2.optionHeight;
          return (
            /*#__PURE__*/
            _react["default"].createElement(AutocompleteSkin, _extends({
              error: error || _this2.state.error,
              filteredOptions: _this2.state.filteredOptions,
              getSelectionProps: _this2.getSelectionProps,
              handleAutocompleteClick: _this2.handleAutocompleteClick,
              handleChange: _this2.handleChange,
              handleInputChange: _this2.handleInputChange,
              inputRef: _this2.inputElement,
              inputValue: _this2.state.inputValue,
              isOpen: _this2.state.isOpen,
              onKeyDown: _this2.onKeyDown,
              optionsMaxHeight: optionsMaxHeight,
              optionsRef: _this2.optionsElement,
              removeOption: _this2.removeOption,
              rootRef: _this2.rootElement,
              selectedOptions: _this2.state.selectedOptions,
              suggestionsRef: _this2.suggestionsElement,
              theme: _this2.state.composedTheme,
              toggleMouseLocation: _this2.toggleMouseLocation,
              toggleOpen: _this2.toggleOpen,
              optionHeight: optionHeight
            }, rest))
          );
        })
      );
    } // ======== PRIVATE METHOD ==========

  }]);

  return AutocompleteBase;
}(_react.Component);

_defineProperty(AutocompleteBase, "displayName", 'Autocomplete');

_defineProperty(AutocompleteBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  error: null,
  invalidCharsRegex: /[^a-zA-Z0-9\s]/g,
  // only allow letters and numbers by default
  isOpeningUpward: false,
  maxVisibleOptions: 10,
  // max number of visible options
  multipleSameSelections: true,
  // if true then same word can be selected multiple times
  options: [],
  requiredSelections: [],
  sortAlphabetically: true,
  // options are sorted alphabetically by default
  theme: null,
  themeId: _2.IDENTIFIERS.AUTOCOMPLETE,
  themeOverrides: {}
});

var Autocomplete = (0, _withTheme.withTheme)(AutocompleteBase);
exports.Autocomplete = Autocomplete;
//# sourceMappingURL=Autocomplete.js.map