"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Bubble = void 0;

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _events = require("../utils/events");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BubbleBase =
/*#__PURE__*/
function (_Component) {
  _inherits(BubbleBase, _Component);

  var _super = _createSuper(BubbleBase);

  // declare ref types
  // define static properties
  function BubbleBase(props) {
    var _this;

    _classCallCheck(this, BubbleBase);

    _this = _super.call(this, props); // define ref

    _defineProperty(_assertThisInitialized(_this), "rootElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "_hasEventListeners", false);

    _defineProperty(_assertThisInitialized(_this), "_handleScrollEventListener", function (action) {
      // const rootNode = this.rootElement;
      var _assertThisInitialize = _assertThisInitialized(_this),
          rootElement = _assertThisInitialize.rootElement;

      if (rootElement) {
        var scrollableNode = _this._getFirstScrollableParent(rootElement);

        if (scrollableNode) {
          if (action === 'add') {
            scrollableNode.addEventListener('scroll', _this._updatePosition);
          } else if (action === 'remove') {
            scrollableNode.removeEventListener('scroll', _this._updatePosition);
          }
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_getFirstScrollableParent", function (element) {
      if (element == null) return null;

      var _assertThisInitialize2 = _assertThisInitialized(_this),
          rootElement = _assertThisInitialize2.rootElement;

      var node = {}.hasOwnProperty.call(element, 'current') ? element.current : element;

      if (rootElement) {
        if (node === rootElement.current || node.scrollHeight <= node.clientHeight) {
          return _this._getFirstScrollableParent(node.parentElement);
        }
      }

      return node;
    });

    _defineProperty(_assertThisInitialized(_this), "_updatePosition", function () {
      var _this$props = _this.props,
          isOpeningUpward = _this$props.isOpeningUpward,
          targetRef = _this$props.targetRef;

      var _assertThisInitialize3 = _assertThisInitialized(_this),
          rootElement = _assertThisInitialize3.rootElement;

      var target = targetRef && typeof targetRef !== 'string' ? targetRef.current : null; // Without a target, try to fallback to the parent node

      if (!target) {
        //  Only proceed if the root element is defined
        if (!rootElement || !rootElement.current) return;
        target = rootElement.current.parentElement;
      }

      var targetRect = target.getBoundingClientRect();
      var positionY;

      if (isOpeningUpward) {
        // Since we don't know the height of the bubble before rendering it we positioning
        // it with { bottom: XYpx } (within the viewport) and need this calculation:
        positionY = window.innerHeight - targetRect.top;
      } else {
        positionY = targetRect.bottom;
      }

      var position = {
        width: targetRect.width,
        positionX: targetRect.left,
        positionY: positionY
      };

      _this.setState({
        position: position
      });
    });

    _this.rootElement = (0, _createRef["default"])();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      position: null
    };
    return _this;
  }

  _createClass(BubbleBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        if (_this2.props.isFloating) _this2._updatePosition();
      }, 0);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var isHidden = this.props.isHidden;
      var didVisibilityChange = isHidden !== prevProps.isHidden;
      var wasBubbleHidden = !prevProps.isHidden && isHidden;

      if (prevProps.isFloating && !isHidden && !this._hasEventListeners) {
        this._handleScrollEventListener('add');

        (0, _events.addDocumentListeners)(this._getDocumentEvents());
        window.addEventListener('resize', this._updatePosition);
        this._hasEventListeners = true;
      }

      if (wasBubbleHidden) this._removeAllEventListeners();
      if (didVisibilityChange) this._updatePosition();

      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this._hasEventListeners) this._removeAllEventListeners();
    } // =========== PRIVATE HELPERS ==============

  }, {
    key: "_removeAllEventListeners",
    value: function _removeAllEventListeners() {
      if (this._hasEventListeners) {
        (0, _events.removeDocumentListeners)(this._getDocumentEvents());

        this._handleScrollEventListener('remove');

        window.removeEventListener('resize', this._updatePosition);
        this._hasEventListeners = false;
      }
    }
  }, {
    key: "_getDocumentEvents",
    value: function _getDocumentEvents() {
      return {
        resize: this._updatePosition,
        scroll: this._updatePosition
      };
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props2 = this.props,
          skin = _this$props2.skin,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          context = _this$props2.context,
          rest = _objectWithoutProperties(_this$props2, ["skin", "theme", "themeOverrides", "context"]);

      var BubbleSkin = skin || context.skins[_.IDENTIFIERS.BUBBLE];
      return (
        /*#__PURE__*/
        _react["default"].createElement(BubbleSkin, _extends({
          rootRef: this.rootElement,
          position: this.state.position,
          theme: this.state.composedTheme
        }, rest))
      );
    }
  }]);

  return BubbleBase;
}(_react.Component);

_defineProperty(BubbleBase, "displayName", 'Bubble');

_defineProperty(BubbleBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  isCentered: false,
  isHidden: false,
  isFloating: false,
  isOpeningUpward: false,
  isTransparent: true,
  arrowRelativeToTip: false,
  noArrow: false,
  theme: null,
  themeId: _.IDENTIFIERS.BUBBLE,
  themeOverrides: {}
});

var Bubble = (0, _withTheme.withTheme)(BubbleBase);
exports.Bubble = Bubble;
//# sourceMappingURL=Bubble.js.map