"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GlobalListeners = void 0;

var _debounce2 = _interopRequireDefault(require("lodash/debounce"));

var _react = _interopRequireWildcard(require("react"));

var _events = require("../../utils/events");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var GlobalListeners =
/*#__PURE__*/
function (_Component) {
  _inherits(GlobalListeners, _Component);

  var _super = _createSuper(GlobalListeners);

  // define static properties
  function GlobalListeners(props) {
    var _this;

    _classCallCheck(this, GlobalListeners);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "_removeListenersAndToggle", function () {
      var _this$props = _this.props,
          optionsIsOpen = _this$props.optionsIsOpen,
          optionsRef = _this$props.optionsRef;

      _this._removeGlobalListeners(); // before toggle, ensure options is open and optionsRef exists on DOM


      if (!optionsIsOpen || !optionsRef || !optionsRef.current) {
        return;
      }

      _this.props.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "_getDocumentListeners", function () {
      return {
        click: _this._handleDocumentClick,
        scroll: _this._handleDocumentScroll
      };
    });

    _defineProperty(_assertThisInitialized(_this), "_getWindowListeners", function () {
      return {
        resize: _this._handleWindowResize
      };
    });

    _defineProperty(_assertThisInitialized(_this), "_handleDocumentClick", function (event) {
      var _this$props2 = _this.props,
          optionsIsOpen = _this$props2.optionsIsOpen,
          rootRef = _this$props2.rootRef; // ensure Options is open

      if (!optionsIsOpen || !rootRef || !rootRef.current) {
        return;
      } // return early if the user clicked an element within the parent component
      // for example, the parent component could be Autocomplete or Select


      if ((0, _events.targetIsDescendant)(event, rootRef.current)) {
        return;
      } // otherwise, remove all listeners and close Options


      _this._removeListenersAndToggle();
    });

    _defineProperty(_assertThisInitialized(_this), "_handleWindowResize", function () {
      return _this._removeListenersAndToggle();
    });

    _defineProperty(_assertThisInitialized(_this), "_handleDocumentScroll", function () {
      return _this._removeListenersAndToggle();
    });

    _defineProperty(_assertThisInitialized(_this), "_addCalculateMaxHeightListeners", function () {
      var _document, _window;

      var scrollListener = ['scroll', (0, _debounce2["default"])(_this._calculateOptionsMaxHeight, 300, {
        leading: true
      }), true];
      var resizeListener = ['resize', (0, _debounce2["default"])(_this._calculateOptionsMaxHeight, 300)];

      (_document = document).addEventListener.apply(_document, scrollListener);

      (_window = window).addEventListener.apply(_window, resizeListener);
    });

    _defineProperty(_assertThisInitialized(_this), "_calculateOptionsMaxHeight", function () {
      var _document2 = document,
          documentElement = _document2.documentElement;
      var _this$props3 = _this.props,
          rootRef = _this$props3.rootRef,
          optionsIsOpeningUpward = _this$props3.optionsIsOpeningUpward,
          optionsIsOpen = _this$props3.optionsIsOpen,
          optionsRef = _this$props3.optionsRef,
          toggleOpen = _this$props3.toggleOpen,
          mouseIsOverOptions = _this$props3.mouseIsOverOptions,
          mouseIsOverRoot = _this$props3.mouseIsOverRoot; // checks if Options are open & being scrolled upon via mouse position prior to toggling closed

      var isOptionsInDOM = optionsRef && optionsRef.current;
      var doDocumentStylesExist = documentElement && documentElement.style;

      if (!rootRef || !rootRef.current || !doDocumentStylesExist || !isOptionsInDOM) {
        return;
      }

      optionsIsOpen && !mouseIsOverOptions && !mouseIsOverRoot && toggleOpen();

      var _rootRef$current$getB = rootRef.current.getBoundingClientRect(),
          height = _rootRef$current$getB.height,
          top = _rootRef$current$getB.top; // opening upwards case


      if (optionsIsOpeningUpward && top < window.innerHeight) {
        _this.setState({
          optionsMaxHeight: top - 20
        });

        return;
      } // opening downwards case


      var optionsMaxHeight = window.innerHeight - top - height - 30;

      if (!optionsIsOpeningUpward && optionsMaxHeight > 0) {
        _this.setState({
          optionsMaxHeight: optionsMaxHeight
        });
      }
    });

    _this.state = {
      optionsMaxHeight: 300
    };
    return _this;
  }

  _createClass(GlobalListeners, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.optionsIsOpen) {
        return;
      } // adds scroll and resize event listeners for calculating Options max-height


      this._addCalculateMaxHeightListeners(); // runs initial Options max-height calculation


      this._calculateOptionsMaxHeight();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var optionsIsOpen = this.props.optionsIsOpen; // if Options is transferring from closed to open, add listeners
      // if Options is transferring from open to closed, remove listeners

      if (!prevProps.optionsIsOpen && optionsIsOpen) {
        // first remove max-height calc handler on scroll and resize
        // then add toggle handler on scroll and resize
        this._removeGlobalListeners();

        (0, _events.addWindowListeners)(this._getWindowListeners());
        (0, _events.addDocumentListeners)(this._getDocumentListeners());
      } else if (prevProps.optionsIsOpen && !optionsIsOpen) {
        // remove toggle handler on scroll and resize
        // then add calc max-height calc handler on scroll and resize
        this._removeGlobalListeners();

        this._addCalculateMaxHeightListeners();
      }
    } // before unmounting, remove all global listeners

  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this._removeGlobalListeners();
    } // removes all event listeners from document and window

  }, {
    key: "_removeGlobalListeners",
    value: function _removeGlobalListeners() {
      (0, _events.removeDocumentListeners)(this._getDocumentListeners());
      (0, _events.removeWindowListeners)(this._getWindowListeners());
    } // removes all global listeners, then closes Options

  }, {
    key: "render",
    value: function render() {
      var optionsMaxHeight = this.state.optionsMaxHeight;
      return (
        /*#__PURE__*/
        _react["default"].createElement(_react.Fragment, null, this.props.children({
          optionsMaxHeight: optionsMaxHeight
        }))
      );
    }
  }]);

  return GlobalListeners;
}(_react.Component);

exports.GlobalListeners = GlobalListeners;

_defineProperty(GlobalListeners, "displayName", 'GlobalListeners');

_defineProperty(GlobalListeners, "defaultProps", {
  optionsIsOpen: false
});
//# sourceMappingURL=GlobalListeners.js.map