"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfiniteScroll = void 0;

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var InfiniteScrollBase =
/*#__PURE__*/
function (_Component) {
  _inherits(InfiniteScrollBase, _Component);

  var _super = _createSuper(InfiniteScrollBase);

  // declare ref types
  // define static properties
  function InfiniteScrollBase(props) {
    var _this;

    _classCallCheck(this, InfiniteScrollBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "scrollContainer", void 0);

    _defineProperty(_assertThisInitialized(_this), "_handleFetchData", function () {
      return _this.props.fetchData(_this.setState.bind(_assertThisInitialized(_this)));
    });

    _defineProperty(_assertThisInitialized(_this), "_handleScroll", function () {
      var _this$state = _this.state,
          error = _this$state.error,
          isLoading = _this$state.isLoading,
          hasMoreData = _this$state.hasMoreData; // return early for error, loading, or lack of future data

      if (error || isLoading || !hasMoreData) {
        return;
      }

      return _this._checkForScrollBottom();
    });

    _defineProperty(_assertThisInitialized(_this), "_checkForScrollBottom", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          scrollContainer = _assertThisInitialize.scrollContainer,
          threshold = _assertThisInitialize.props.threshold;

      if (!scrollContainer.current) return;
      var _scrollContainer$curr = scrollContainer.current,
          offsetHeight = _scrollContainer$curr.offsetHeight,
          scrollTop = _scrollContainer$curr.scrollTop,
          scrollHeight = _scrollContainer$curr.scrollHeight;

      if (offsetHeight + scrollTop >= scrollHeight - threshold) {
        return _this._handleFetchData();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_isFunction", function (renderProp) {
      return renderProp && typeof renderProp === 'function';
    });

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides; // refs

    _this.scrollContainer = (0, _createRef["default"])();
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      data: [],
      error: false,
      isLoading: false,
      hasMoreData: true
    };
    return _this;
  }

  _createClass(InfiniteScrollBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var scrollContainer = this.scrollContainer;

      this._handleFetchData();

      if (!scrollContainer.current) return;
      scrollContainer.current.addEventListener('scroll', this._handleScroll);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    } // calls user's fetchData function from props

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          context = _this$props.context,
          renderItems = _this$props.renderItems,
          skin = _this$props.skin,
          themeId = _this$props.themeId,
          _this$state2 = this.state,
          composedTheme = _this$state2.composedTheme,
          data = _this$state2.data,
          error = _this$state2.error,
          hasMoreData = _this$state2.hasMoreData,
          isLoading = _this$state2.isLoading,
          scrollContainer = this.scrollContainer;

      if (!this._isFunction(renderItems)) {
        return null;
      }

      var InfiniteScrollSkin = skin || context.skins[_.IDENTIFIERS.INFINITE_SCROLL];
      return (
        /*#__PURE__*/
        _react["default"].createElement(InfiniteScrollSkin, {
          className: className,
          data: data,
          error: error,
          hasMoreData: hasMoreData,
          isLoading: isLoading,
          renderItems: renderItems,
          scrollContainerRef: scrollContainer,
          theme: composedTheme,
          themeId: themeId
        })
      );
    }
  }]);

  return InfiniteScrollBase;
}(_react.Component);

_defineProperty(InfiniteScrollBase, "displayName", 'InfiniteScroll');

_defineProperty(InfiniteScrollBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  fetchData: function fetchData() {},
  theme: null,
  themeId: _.IDENTIFIERS.INFINITE_SCROLL,
  themeOverrides: {},
  threshold: 250
});

var InfiniteScroll = (0, _withTheme.withTheme)(InfiniteScrollBase);
exports.InfiniteScroll = InfiniteScroll;
//# sourceMappingURL=InfiniteScroll.js.map