"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Input = void 0;

var _flow2 = _interopRequireDefault(require("lodash/flow"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var InputBase =
/*#__PURE__*/
function (_Component) {
  _inherits(InputBase, _Component);

  var _super = _createSuper(InputBase);

  function InputBase(props) {
    var _props$inputRef;

    var _this;

    _classCallCheck(this, InputBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled,
          readOnly = _this$props.readOnly;
      if (disabled || readOnly) return;
      if (onChange) onChange(_this._processValue(event.target.value), event);
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (!inputElement.current) return;
      inputElement.current.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "_setError", function (error) {
      var setError = _this.props.setError; // checks for setError func from FormField component
      // if this Input instance is being used within the render function
      // of a FormField instance, the error field within FormField's local state
      // will be set

      if (setError) setError(error);

      _this.setState({
        error: error
      });
    });

    _this.inputElement = (_props$inputRef = props.inputRef) !== null && _props$inputRef !== void 0 ? _props$inputRef : (0, _createRef["default"])();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      error: ''
    };
    return _this;
  }

  _createClass(InputBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.autoFocus) this.focus();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "_processValue",
    value: function _processValue(value) {
      return (0, _flow2["default"])([this._enforceStringValue, this._enforceMaxLength, this._enforceMinLength]).call(this, value);
    }
  }, {
    key: "_enforceStringValue",
    value: function _enforceStringValue(value) {
      if (!(0, _isString2["default"])(value)) {
        throw new Error('Values passed to Input::onChange must be strings');
      }

      return value;
    }
  }, {
    key: "_enforceMaxLength",
    value: function _enforceMaxLength(value) {
      var maxLength = this.props.maxLength;
      var isTooLong = maxLength != null && value.length > maxLength;
      return isTooLong ? value.substring(0, maxLength) : value;
    }
  }, {
    key: "_enforceMinLength",
    value: function _enforceMinLength(value) {
      var minLength = this.props.minLength;
      var isTooShort = minLength != null && value.length < minLength;

      if (isTooShort) {
        this._setError('Please enter a valid input');
      } else if (this.state.error !== '') {
        this._setError('');
      }

      return value;
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props2 = this.props,
          skin = _this$props2.skin,
          context = _this$props2.context,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          onChange = _this$props2.onChange,
          error = _this$props2.error,
          maxLength = _this$props2.maxLength,
          minLength = _this$props2.minLength,
          setError = _this$props2.setError,
          autoFocus = _this$props2.autoFocus,
          rest = _objectWithoutProperties(_this$props2, ["skin", "context", "theme", "themeOverrides", "onChange", "error", "maxLength", "minLength", "setError", "autoFocus"]);

      var InputSkin = skin || context.skins[_.IDENTIFIERS.INPUT];
      return (
        /*#__PURE__*/
        _react["default"].createElement(InputSkin, _extends({
          error: error || this.state.error,
          onChange: this.onChange,
          inputRef: this.inputElement,
          theme: this.state.composedTheme
        }, rest))
      );
    }
  }]);

  return InputBase;
}(_react.Component);

_defineProperty(InputBase, "displayName", 'Input');

_defineProperty(InputBase, "defaultProps", {
  autoFocus: false,
  context: (0, _withTheme.createEmptyContext)(),
  error: '',
  readOnly: false,
  theme: null,
  themeId: _.IDENTIFIERS.INPUT,
  themeOverrides: {},
  value: ''
});

var Input = (0, _withTheme.withTheme)(InputBase);
exports.Input = Input;
//# sourceMappingURL=Input.js.map