"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NumericInput = void 0;

var _string = require("lodash/string");

var _react = _interopRequireWildcard(require("react"));

var _bignumber = _interopRequireDefault(require("bignumber.js"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _strings = require("../utils/strings");

var _Input = require("./Input");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var NumericInputBase =
/*#__PURE__*/
function (_Component) {
  _inherits(NumericInputBase, _Component);

  var _super = _createSuper(NumericInputBase);

  function NumericInputBase(props) {
    var _this;

    _classCallCheck(this, NumericInputBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "_hasInputBeenChanged", false);

    _defineProperty(_assertThisInitialized(_this), "onChange", function (newValue, event) {
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange;

      var result = _this.processValueChange(event.nativeEvent);

      if (result) {
        _this._hasInputBeenChanged = true;
        var hasValueChanged = value !== result.value;

        if (hasValueChanged && onChange) {
          onChange(result.value, event);
        }

        _this.setState({
          inputCaretPosition: result.caretPosition,
          fallbackInputValue: result.fallbackInputValue
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setInputCaretPosition", function (position) {
      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (!inputElement.current) return;
      var input = inputElement.current;
      input.selectionStart = position;
      input.selectionEnd = position;
    });

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      var _assertThisInitialize2 = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize2.inputElement;

      if (!inputElement.current) return;
      inputElement.current.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "onBlur", function (event) {
      var _this$props$onBlur, _this$props2;

      _this.setState({
        fallbackInputValue: null
      });

      (_this$props$onBlur = (_this$props2 = _this.props).onBlur) === null || _this$props$onBlur === void 0 ? void 0 : _this$props$onBlur.call(_this$props2, event);
    });

    _this.inputElement = (0, _createRef["default"])();
    _this.state = {
      inputCaretPosition: 0,
      fallbackInputValue: null
    };
    return _this;
  }

  _createClass(NumericInputBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var inputElement = this.inputElement;
      var autoFocus = this.props.autoFocus;

      if (autoFocus) {
        this.focus();

        if (inputElement && inputElement.current) {
          this.setState({
            inputCaretPosition: inputElement.current.selectionStart
          });
        }
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var value = this.props.value;
      var inputCaretPosition = this.state.inputCaretPosition;
      var hasValueBeenChanged = value !== prevProps.value;
      var hasCaretBeenChanged = inputCaretPosition !== prevState.inputCaretPosition;

      if (this._hasInputBeenChanged || hasValueBeenChanged || hasCaretBeenChanged) {
        this.setInputCaretPosition(inputCaretPosition);
      }

      this._hasInputBeenChanged = false;
    }
  }, {
    key: "processValueChange",

    /**
     * 1. Handle edge cases that don't need further processing
     * 2. Clean the given value
     * 3. Final processing
     */
    value: function processValueChange(event) {
      var _this$props3 = this.props,
          allowSigns = _this$props3.allowSigns,
          decimalPlaces = _this$props3.decimalPlaces,
          value = _this$props3.value;
      var inputType = event.inputType,
          target = event.target;

      var _this$getBigNumberFor = this.getBigNumberFormat(),
          decimalSeparator = _this$getBigNumberFor.decimalSeparator,
          groupSeparator = _this$getBigNumberFor.groupSeparator;

      var changedCaretPosition = target.selectionStart;
      var valueToProcess = target.value;
      var fallbackInputValue = this.state.fallbackInputValue;
      var isBackwardDelete = inputType === 'deleteContentBackward';
      var isForwardDelete = inputType === 'deleteContentForward';
      var isDeletion = isForwardDelete || isBackwardDelete;
      var isInsert = inputType === 'insertText';
      var deleteCaretCorrection = isBackwardDelete ? 0 : 1;
      var validInputSignsRegExp = new RegExp("^([-])?([0-9".concat(decimalSeparator).concat(groupSeparator, "]+)?$"));
      var validInputNoSignsRegExp = new RegExp("^([0-9".concat(decimalSeparator).concat(groupSeparator, "]+)?$"));
      var validInputRegex = allowSigns ? validInputSignsRegExp : validInputNoSignsRegExp;
      var valueHasLeadingZero = /^0[1-9]/.test(valueToProcess);
      /**
       * ========= HANDLE HARD EDGE-CASES =============
       */
      // Case: invalid characters entered -> refuse!

      if (!validInputRegex.test(valueToProcess)) {
        return {
          caretPosition: changedCaretPosition - 1,
          fallbackInputValue: fallbackInputValue,
          value: value
        };
      } // Case: Everything was deleted -> reset state


      if (valueToProcess === '') {
        return {
          value: null,
          caretPosition: 0,
          fallbackInputValue: null
        };
      } // Case: value is the same as the fallback (which is always shown if defined)


      if (valueToProcess === this.state.fallbackInputValue) return null; // Case: Just minus sign was entered

      if (valueToProcess === '-') {
        return {
          value: null,
          caretPosition: 1,
          fallbackInputValue: '-'
        };
      } // Case: Just minus sign was entered


      if (valueToProcess === groupSeparator) {
        return {
          value: null,
          caretPosition: 0,
          fallbackInputValue: null
        };
      }
      /**
       * ========= CLEAN THE INPUT =============
       */


      var currentNumber = value == null ? new _bignumber["default"]('0') : new _bignumber["default"](value);
      var currentValue = fallbackInputValue !== null && fallbackInputValue !== void 0 ? fallbackInputValue : this.valueToFormattedString(currentNumber);
      var currentNumberOfDecimalSeparators = this.getNumberOfDecimalSeparators(currentValue);
      var hadDecimalSeparatorBefore = currentNumberOfDecimalSeparators > 0; // New Value

      var newValue = valueToProcess;
      var newCaretPosition = changedCaretPosition;
      var newNumberOfDecimalSeparators = this.getNumberOfDecimalSeparators(newValue); // Case: A second decimal separator was added somewhere

      if (hadDecimalSeparatorBefore && newNumberOfDecimalSeparators === 2) {
        var oldFirstIndex = currentValue.indexOf(decimalSeparator);
        var newFirstIndex = newValue.indexOf(decimalSeparator);
        var wasSeparatorAddedBeforeOldOne = newFirstIndex < oldFirstIndex; // Remove the second decimal point and set caret position

        newValue = (0, _strings.removeCharAtPosition)(newValue, wasSeparatorAddedBeforeOldOne ? newValue.lastIndexOf(decimalSeparator) : oldFirstIndex);
        newCaretPosition = newValue.indexOf(decimalSeparator) + 1;
      }
      /**
       * ========= PROCESS CLEANED INPUT =============
       */
      // Case: Just a decimal separator was entered


      if (newValue === decimalSeparator) {
        return {
          value: '0',
          caretPosition: 2,
          fallbackInputValue: decimalPlaces > 0 ? null : "0".concat(decimalSeparator)
        };
      } // Case: Decimal separator was added at the beginning of number


      if (newValue.charAt(0) === decimalSeparator) {
        var newCaretPos = isInsert ? 2 : 1;
        return {
          value: this.bigNumberToFixed(new _bignumber["default"]("0.".concat(newValue.substr(1)))),
          caretPosition: newCaretPos,
          fallbackInputValue: null
        };
      }

      var newNumber = newValue === '' ? null : this.formattedValueToBigNumber(newValue); // Case: Invalid change has been made -> ignore it

      if (newNumber == null) {
        var deleteAdjustment = isBackwardDelete ? 0 : 1; // special cases when deleting dot

        var insertAdjustment = -1; // don't move caret if numbers are "inserted"

        return {
          caretPosition: changedCaretPosition + (isDeletion ? deleteAdjustment : insertAdjustment),
          fallbackInputValue: fallbackInputValue,
          value: this.bigNumberToFixed(currentNumber)
        };
      }

      var formattedNewNumber = this.valueToFormattedString(newNumber); // Case: Dot was added at the end of number

      if (!isDeletion && newValue.charAt(newValue.length - 1) === decimalSeparator) {
        return {
          value: this.bigNumberToFixed(newNumber),
          caretPosition: changedCaretPosition,
          fallbackInputValue: decimalPlaces > 0 ? null : formattedNewNumber + decimalSeparator,
          minimumFractionDigits: 0
        };
      } // Case: Decimal separator was deleted while number of decimal places specified


      var hasDecimalPlaces = decimalPlaces != null;
      var wasDecimalSeparatorRemoved = hadDecimalSeparatorBefore && !newNumberOfDecimalSeparators;

      if (wasDecimalSeparatorRemoved && hasDecimalPlaces && !isInsert) {
        return {
          caretPosition: newCaretPosition + deleteCaretCorrection,
          fallbackInputValue: null,
          value: this.bigNumberToFixed(currentNumber)
        };
      } // Case: Valid change has been made


      var hasNumberChanged = !this.isSameValue(currentNumber, newNumber);
      var groupSeparatorsDiff = this.getNumberOfGroupSeparators(formattedNewNumber) - this.getNumberOfGroupSeparators(newValue);
      var hasNumberOfGroupSeparatorsChanged = groupSeparatorsDiff > 0;
      var onlyNumberOfGroupSeparatorsChanged = !hasNumberChanged && hasNumberOfGroupSeparatorsChanged;
      var leadingZeroCorrection = valueHasLeadingZero ? -1 : 0;
      var caretCorrection = (onlyNumberOfGroupSeparatorsChanged ? deleteCaretCorrection : groupSeparatorsDiff) + leadingZeroCorrection;
      return {
        caretPosition: Math.max(newCaretPosition + caretCorrection, 0),
        fallbackInputValue: null,
        value: this.bigNumberToFixed(newNumber)
      };
    }
  }, {
    key: "getBigNumberFormat",
    value: function getBigNumberFormat() {
      var _this$props$bigNumber;

      return (_this$props$bigNumber = this.props.bigNumberFormat) !== null && _this$props$bigNumber !== void 0 ? _this$props$bigNumber : _bignumber["default"].config().FORMAT;
    }
  }, {
    key: "valueToFormattedString",
    value: function valueToFormattedString(number) {
      var _this$props4 = this.props,
          bigNumberFormat = _this$props4.bigNumberFormat,
          decimalPlaces = _this$props4.decimalPlaces,
          roundingMode = _this$props4.roundingMode;
      var debugSetting = _bignumber["default"].DEBUG;
      if (_bignumber["default"].isBigNumber(number) && number.isNaN()) return '';

      try {
        _bignumber["default"].DEBUG = true;
        return new _bignumber["default"](number).toFormat(decimalPlaces, roundingMode, _objectSpread(_objectSpread({}, _bignumber["default"].config().FORMAT), bigNumberFormat));
      } catch (e) {
        return '';
      } finally {
        _bignumber["default"].DEBUG = debugSetting;
      }
    }
  }, {
    key: "bigNumberToFixed",
    value: function bigNumberToFixed(number) {
      var _this$props5 = this.props,
          decimalPlaces = _this$props5.decimalPlaces,
          roundingMode = _this$props5.roundingMode;
      return number.toFixed(decimalPlaces, roundingMode);
    }
  }, {
    key: "formattedValueToBigNumber",
    value: function formattedValueToBigNumber(value) {
      var _this$getBigNumberFor2 = this.getBigNumberFormat(),
          decimalSeparator = _this$getBigNumberFor2.decimalSeparator,
          groupSeparator = _this$getBigNumberFor2.groupSeparator;

      return new _bignumber["default"](value.replace(escapedGlobalRegExp(groupSeparator), '').replace(escapedGlobalRegExp(decimalSeparator), '.'));
    }
  }, {
    key: "getNumberOfGroupSeparators",
    value: function getNumberOfGroupSeparators(value) {
      var _this$getBigNumberFor3 = this.getBigNumberFormat(),
          groupSeparator = _this$getBigNumberFor3.groupSeparator;

      return (value.match(escapedGlobalRegExp(groupSeparator)) || []).length;
    }
  }, {
    key: "getNumberOfDecimalSeparators",
    value: function getNumberOfDecimalSeparators(value) {
      var _this$getBigNumberFor4 = this.getBigNumberFormat(),
          decimalSeparator = _this$getBigNumberFor4.decimalSeparator;

      return (value.match(escapedGlobalRegExp(decimalSeparator)) || []).length;
    }
  }, {
    key: "isSameValue",
    value: function isSameValue(first, second) {
      return _bignumber["default"].isBigNumber(first) ? first.isEqualTo(second) : first === second;
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props6 = this.props,
          onChange = _this$props6.onChange,
          value = _this$props6.value,
          rest = _objectWithoutProperties(_this$props6, ["onChange", "value"]);

      var inputValue = this.state.fallbackInputValue ? this.state.fallbackInputValue : this.valueToFormattedString(value);
      return (
        /*#__PURE__*/
        _react["default"].createElement(_Input.Input, _extends({
          inputRef: this.inputElement,
          onChange: this.onChange,
          onBlur: this.onBlur,
          value: inputValue
        }, rest))
      );
    }
  }]);

  return NumericInputBase;
}(_react.Component);

_defineProperty(NumericInputBase, "displayName", 'NumericInput');

_defineProperty(NumericInputBase, "defaultProps", {
  allowSigns: true,
  readOnly: false,
  roundingMode: _bignumber["default"].ROUND_FLOOR,
  value: null
});

var NumericInput = (0, _withTheme.withTheme)(NumericInputBase);
exports.NumericInput = NumericInput;

function escapedGlobalRegExp(regex) {
  return new RegExp((0, _string.escapeRegExp)(regex), 'g');
}
//# sourceMappingURL=NumericInput.js.map