"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = void 0;

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _GlobalListeners = require("./HOC/GlobalListeners");

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SelectBase =
/*#__PURE__*/
function (_Component) {
  _inherits(SelectBase, _Component);

  var _super = _createSuper(SelectBase);

  // declare ref types
  // define static properties
  function SelectBase(props) {
    var _this;

    _classCallCheck(this, SelectBase);

    _this = _super.call(this, props); // define ref

    _defineProperty(_assertThisInitialized(_this), "rootElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "inputElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "optionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      return _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "toggleOpen", function () {
      if (_this.state.isOpen && _this.optionsElement && _this.optionsElement.current) {
        // set Options scroll position to top on close
        _this.optionsElement.current.scrollTop = 0;
      }

      _this.setState({
        isOpen: !_this.state.isOpen
      });
    });

    _defineProperty(_assertThisInitialized(_this), "toggleMouseLocation", function () {
      return _this.setState({
        mouseIsOverOptions: !_this.state.mouseIsOverOptions
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleInputClick", function (event) {
      event.stopPropagation();
      event.preventDefault();

      var _assertThisInitialize = _assertThisInitialized(_this),
          inputElement = _assertThisInitialize.inputElement;

      if (inputElement.current && document.activeElement === inputElement.current) {
        inputElement.current.blur();
      }

      _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (option, event) {
      // check if the user passed an onChange handler and call it
      if (_this.props.onChange) _this.props.onChange(option.value, event); // onChange is called when an option is selected, so close options

      _this.toggleOpen();
    });

    _defineProperty(_assertThisInitialized(_this), "getSelectedOption", function () {
      var _this$props = _this.props,
          options = _this$props.options,
          value = _this$props.value,
          allowBlank = _this$props.allowBlank;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;
          if (option.value === value) return option;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator["return"] != null) {
            _iterator["return"]();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!allowBlank) return options[0];
    });

    _this.rootElement = (0, _createRef["default"])();
    _this.inputElement = (0, _createRef["default"])();
    _this.optionsElement = (0, _createRef["default"])();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      isOpen: false,
      mouseIsOverOptions: false
    };
    return _this;
  }

  _createClass(SelectBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      // check for autoFocus of input element
      if (this.props.autoFocus) {
        return this.focus();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    } // ========= PUBLIC SKIN API =========
    // applying focus to the input element will
    // toggle options open because Select's input is read only

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      // destructuring props ensures only the "...rest" get passed down
      var _this$props2 = this.props,
          skin = _this$props2.skin,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          autoFocus = _this$props2.autoFocus,
          context = _this$props2.context,
          allowBlank = _this$props2.allowBlank,
          optionHeight = _this$props2.optionHeight,
          rest = _objectWithoutProperties(_this$props2, ["skin", "theme", "themeOverrides", "autoFocus", "context", "allowBlank", "optionHeight"]);

      var SelectSkin = skin || context.skins[_.IDENTIFIERS.SELECT];
      return (
        /*#__PURE__*/
        _react["default"].createElement(_GlobalListeners.GlobalListeners, {
          mouseIsOverOptions: this.state.mouseIsOverOptions,
          optionsIsOpen: this.state.isOpen,
          optionsIsOpeningUpward: this.props.isOpeningUpward,
          optionsRef: this.optionsElement,
          rootRef: this.rootElement,
          toggleOpen: this.toggleOpen
        }, function (_ref) {
          var optionsMaxHeight = _ref.optionsMaxHeight;
          return (
            /*#__PURE__*/
            _react["default"].createElement(SelectSkin, _extends({
              isOpen: _this2.state.isOpen,
              rootRef: _this2.rootElement,
              inputRef: _this2.inputElement,
              optionsRef: _this2.optionsElement,
              optionsMaxHeight: optionsMaxHeight,
              theme: _this2.state.composedTheme,
              getSelectedOption: _this2.getSelectedOption,
              handleInputClick: _this2.handleInputClick,
              handleChange: _this2.handleChange,
              toggleOpen: _this2.toggleOpen,
              toggleMouseLocation: _this2.toggleMouseLocation,
              optionHeight: optionHeight
            }, rest))
          );
        })
      );
    }
  }]);

  return SelectBase;
}(_react.Component);

_defineProperty(SelectBase, "displayName", 'Select');

_defineProperty(SelectBase, "defaultProps", {
  allowBlank: true,
  autoFocus: false,
  context: (0, _withTheme.createEmptyContext)(),
  isOpeningUpward: false,
  options: [],
  theme: null,
  themeOverrides: {},
  themeId: _.IDENTIFIERS.SELECT,
  value: ''
});

var Select = (0, _withTheme.withTheme)(SelectBase);
exports.Select = Select;
//# sourceMappingURL=Select.js.map