"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TextArea = void 0;

var _flow2 = _interopRequireDefault(require("lodash/flow"));

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _react = _interopRequireWildcard(require("react"));

var _createRef = _interopRequireDefault(require("create-react-ref/lib/createRef"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TextAreaBase =
/*#__PURE__*/
function (_Component) {
  _inherits(TextAreaBase, _Component);

  var _super = _createSuper(TextAreaBase);

  // declare ref types
  // define static properties
  function TextAreaBase(props) {
    var _this;

    _classCallCheck(this, TextAreaBase);

    _this = _super.call(this, props); // define ref

    _defineProperty(_assertThisInitialized(_this), "textareaElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "focus", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          textareaElement = _assertThisInitialize.textareaElement;

      if (!textareaElement.current) return;
      textareaElement.current.focus();
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (event) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          disabled = _this$props.disabled;
      if (disabled) return;
      if (onChange) onChange(_this._processValue(event.target.value), event);
    });

    _defineProperty(_assertThisInitialized(_this), "_setError", function (error) {
      return _this.setState({
        error: error
      });
    });

    _this.textareaElement = (0, _createRef["default"])();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      error: ''
    };
    return _this;
  }

  _createClass(TextAreaBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props2 = this.props,
          autoResize = _this$props2.autoResize,
          autoFocus = _this$props2.autoFocus;

      if (autoResize) {
        window.addEventListener('resize', this._handleAutoresize);

        this._handleAutoresize();
      }

      if (autoFocus) {
        this.focus();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.autoResize) this._handleAutoresize();

      if (prevProps !== this.props) {
        if (!prevProps.autoResize && this.props.autoResize) {
          window.addEventListener('resize', this._handleAutoresize);
        } else if (prevProps.autoResize && !this.props.autoResize) {
          window.removeEventListener('resize', this._handleAutoresize);
        }

        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.props.autoResize) {
        window.removeEventListener('resize', this._handleAutoresize);
      }
    }
  }, {
    key: "_processValue",
    value: function _processValue(value) {
      return (0, _flow2["default"])([this._enforceStringValue, this._enforceMaxLength, this._enforceMinLength]).call(this, value);
    }
  }, {
    key: "_enforceStringValue",
    value: function _enforceStringValue(value) {
      if (!(0, _isString2["default"])(value)) {
        throw new Error('Values passed to TextArea::onChange must be strings');
      }

      return value;
    }
  }, {
    key: "_enforceMaxLength",
    value: function _enforceMaxLength(value) {
      var maxLength = this.props.maxLength;
      var isTooLong = maxLength != null && value.length > maxLength;
      return isTooLong ? value.substring(0, maxLength) : value;
    }
  }, {
    key: "_enforceMinLength",
    value: function _enforceMinLength(value) {
      var minLength = this.props.minLength;
      var isTooShort = minLength != null && value.length < minLength;

      if (isTooShort) {
        this._setError('Please enter a valid input');
      } else if (this.state.error !== '') {
        this._setError('');
      }

      return value;
    }
  }, {
    key: "_handleAutoresize",
    value: function _handleAutoresize() {
      var textareaElement = this.textareaElement;
      if (!textareaElement.current) return; // compute the height difference between inner height and outer height

      var style = getComputedStyle(textareaElement.current, '');
      var heightOffset = style.boxSizing === 'content-box' ? -(parseFloat(style.paddingTop) + parseFloat(style.paddingBottom)) : parseFloat(style.borderTopWidth) + parseFloat(style.borderBottomWidth); // resize the input to its content size

      textareaElement.current.style.height = 'auto';
      textareaElement.current.style.height = "".concat(textareaElement.current.scrollHeight + heightOffset, "px");
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props3 = this.props,
          skin = _this$props3.skin,
          theme = _this$props3.theme,
          themeOverrides = _this$props3.themeOverrides,
          onChange = _this$props3.onChange,
          error = _this$props3.error,
          context = _this$props3.context,
          autoFocus = _this$props3.autoFocus,
          autoResize = _this$props3.autoResize,
          rest = _objectWithoutProperties(_this$props3, ["skin", "theme", "themeOverrides", "onChange", "error", "context", "autoFocus", "autoResize"]);

      var TextAreaSkin = skin || context.skins[_.IDENTIFIERS.TEXT_AREA];
      return (
        /*#__PURE__*/
        _react["default"].createElement(TextAreaSkin, _extends({
          error: error || this.state.error,
          onChange: this.onChange,
          textareaRef: this.textareaElement,
          theme: this.state.composedTheme
        }, rest))
      );
    }
  }]);

  return TextAreaBase;
}(_react.Component);

_defineProperty(TextAreaBase, "displayName", 'TextArea');

_defineProperty(TextAreaBase, "defaultProps", {
  autoFocus: false,
  autoResize: true,
  context: (0, _withTheme.createEmptyContext)(),
  theme: null,
  themeId: _.IDENTIFIERS.TEXT_AREA,
  themeOverrides: {},
  value: ''
});

var TextArea = (0, _withTheme.withTheme)(TextAreaBase);
exports.TextArea = TextArea;
//# sourceMappingURL=TextArea.js.map